
#ifndef VOLUMESCENE_H
#define VOLUMESCENE_H

#include <cmath>
#include "Isosurface.h"


class VolumeScene {
public:
  VolumeScene();
  ~VolumeScene();
  
  bool buildIso(unsigned char isovalue, int maxTris);
  void display();
  void renderIso();
  bool resize(int w, int h);
  void setVol(const unsigned char *data, int sx, int sy, int sz);
protected:
  inline bool computeGradient(int x, int y, int z, Vector3 &result);

  int viewportWidth,
      viewportHeight;

  // volume dimensions
  int sizeX, sizeY, sizeZ;
  float scaleX, scaleY, scaleZ, longest;

  // pointer to volume data
  const unsigned char *volData;

  Isosurface isosurface;
  int maxTris;
}; // VolumeScene


#endif

